close all;
clear all;

I = double(rgb2gray(imread('redbloodcell-100.jpg')));

% I = zeros(64,64);
% I(32,32)=1;
% I = double(bwdist(I)<=25);
I = I(10:60,10:70);
I(:) = (I-min(I(:)))/(max(I(:))-min(I(:)));

sig = 1;
siz = 2*round(3*sig) + 1;
g = fspecial('Gaussian',[siz siz],sig);
J = imfilter(I,g,'same','same','replicate');
figure,imagesc(J),colormap(gray),axis image;
title('Blood cell image');

[h,w] = size(J);
W = zeros(h*w,h*w);

sigJ=0.05;
sigd=10;
r2=25*25;
for i=1:h,
    for j=1:w,
        for k=1:h,
            for l=1:w,
                d2 = (i-k)^2 + (j-l)^2;
                if d2<=r2,
                    W((j-1)*h+i,(l-1)*h+k) = exp(-((J(i,j)-J(k,l))^2)/(2*sigJ^2)-d2/(2*sigd^2));
                end
            end
        end
    end
end

A = sparse(W);
D = spdiags(1./(sqrt(sum(W,2))+eps),0,h*w,h*w);
A = speye(h*w) - D*A*D;

[Z,d] = eigs(A,3,'sm');
Y1 = D*(Z(:,2));
Y2 = D*(Z(:,3));
figure,imagesc(reshape(Y1,h,w)),colormap(gray),axis image;
title('Second smallest eigenvector');
figure,imagesc(reshape(Y2,h,w)),colormap(gray),axis image;
title('Third smallest eigenvector');

B2 = reshape(kmeans(Y1(:),2),h,w);
B3 = reshape(kmeans([Y1(:) Y2(:)],3),h,w);

% Y1(:) = (Y1-min(Y1(:)))/(max(Y1(:))-min(Y1(:)));
% level = graythresh(Y);
% B2 = Y>level;
figure,imagesc(B2),colormap(gray),axis image;
title('Clustering on the second smallest eigenvector');
figure,imagesc(B3),colormap(gray),axis image;
title('Clustering on the second and the thrid smallest eigenvectors');

