function nodes = decompose_im_dt(im_scaled,P_scaled,model,layer)
    % go through the image and classify everything
    [ly lx num_colors] = size(im_scaled{1});
    
    mu = model.mu{layer};
    A  = model.A {layer};
    At = model.At{layer};
    %bigmu = repmat(mu,1,ly);
    buf_size = model.buf_size;
    num_labels = model.num_labels;
    
    for scale=1:model.num_scales
        step = 2^(scale-1);
        mybuf_size = buf_size*step;
        bigim{scale} = reflectim(im_scaled{scale},mybuf_size);
        if ~isempty(P_scaled)
            bigP{scale} = reflectim(P_scaled{scale},mybuf_size);
        end
    end
    
    nodes = zeros(ly*lx,1);
    
    where = 1;
    for x=1:lx
         %patches     = zeros( 0, ly);
         %patches2    = zeros( (1+2*buf_size)^2*(num_colors + model.num_labels*double(layer>1)),ly);
         %patches2t   = zeros(ly, (1+2*buf_size)^2*(num_colors + model.num_labels*double(layer>1)));
         %where2      = 1;
         count = 1;
         for scale=1:model.num_scales
             step = 2^(scale-1);
             mybuf_size = model.buf_size*step;
             mypatches     = zeros( (2*buf_size+1)^2*num_colors, ly);
             decompose_im_helper_1col_lo(bigim{scale},mypatches,int32(mybuf_size),int32(ly),int32(lx),int32(num_colors),int32(x),int32(step));
             %patches = [patches; mypatches];
             patchlist{count,1} = mypatches; count=count+1;
             %howmany = (1+2*buf_size)^2*num_colors;
             %patches2 (where2:where2+howmany-1,:)=mypatches;
             %where2=where2+howmany;
         end
         if ~isempty(P_scaled)
             for scale=1:model.num_scales
                 step = 2^(scale-1);
                 mybuf_size = model.buf_size*step;
                 mypatches     = zeros( (2*buf_size+1)^2*num_labels, ly);
                 decompose_im_helper_1col_lo(bigP{scale},mypatches,int32(mybuf_size),int32(ly),int32(lx),int32(num_labels),int32(x),int32(step));
                 %patches = [patches; mypatches];
                 patchlist{count,1} = mypatches; count=count+1;
                 %howmany = (1+2*buf_size)^2*num_labels;
                 %patches2(where2:where2+howmany-1,:)=mypatches;
                 %where2=where2+howmany;
             end
         end
         %patches=cell2mat(patchlist);
         patches=cat(1,patchlist{:});
             
         %X(:,where:where+ly-1) = At*(patches-bigmu);
         
         % strangely, faster to break into multiple lines
         
         %patches = patches-bigmu;
         %rez = At*patches;
         
         %rez = At*(patches-bigmu);         
         %AX = rez;
         %nodes(where:where+ly-1) = mytreeval(model.T{layer},AX);
         
         nodes(where:where+ly-1) = mytreeval_pca(model.T{layer},patches,At,mu,A);
         where = where + ly;
    end
    
%     if round(lx/10) ~= lx/10
%         error('speedup only for lx divisible by 10');
%     end
%     bigpatches = zeros( (2*buf_size+1)^2*num_colors, ly*10);
%     where = 1;
%     for x=1:10:lx-9
%         for dx=0:9
%              decompose_im_helper_1col(bigim,patches,int32(buf_size),int32(ly),int32(lx),int32(num_colors),int32(x+dx));
%              patches = patches-bigmu;
%              bigpatches(:,(1:ly)+dx*ly)=patches;
%         end
%         rez = At*bigpatches;
%         X2(:,where:where+ly*10-1) = rez;
%         
%         where = where + ly*10;
%     end

end