/* Simple test program for the RAD package. */

/* Compute f(n,x) = the product of x[0], x[1], ..., x[n-1] */
/* and the gradient of f for two x values, and print the result. */

//#include "rad.hpp"
#include <stdio.h>
#include "mex.h"   //--This one is required
//#define nanoMatDebug 1 // 1 for safety/error checking; 0 for faster and unsafe(er)
#include "nanoMatT.cpp"
#include "math.h"
#define mmin(X,Y) ((X) < (Y) ? (X) : (Y))
#define mmax(X,Y) ((X) > (Y) ? (X) : (Y))

/*
typedef nanoMat<double> dMat;
typedef nanoMat<int>    iMat;
typedef nanoMat<ADvar> adMat;
typedef ADvar var;
*/


typedef nanoMat<double> dMat;
typedef nanoMat<int>    iMat;
typedef nanoMat<double> adMat;
typedef double var;

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]){
    int i, j, k, l, m, n, y;
    
    dMat  bigim  = dMat(prhs[0]);
    dMat      X  = dMat(prhs[1]);
    int buf_size = iMat(prhs[2])(0);
    int      ly  = iMat(prhs[3])(0);
    int      lx  = iMat(prhs[4])(0);
    int num_colors = iMat(prhs[5])(0);
    
    // MATLAB
    //where = 1;
    //for x=1:lx
    //    for y=1:ly
    //        patch = bigim(y:y+2*buf_size,x:x+2*buf_size,:);
    //        X(:,where) = patch(:);
    //        where = where + 1;
    //    end
    //end
    
    int where = 0;
    for(int x=0; x<lx; x++)
        for(int y=0; y<ly; y++){
            int j = 0;
            for(int col=0; col<num_colors; col++)
                for(int myx=x; myx<=x+2*buf_size; myx++)
                    for(int myy=y; myy<=y+2*buf_size; myy++){
                        X(j,where)=bigim(myy + myx*(ly+2*buf_size) + col*(ly+2*buf_size)*(lx+2*buf_size));
                        j++;
                    }
            
            where++;
        }
    
    //printf("buf_size: %d  ly: %d  lx: %d  num_colors: %d \n", buf_size, ly, lx, num_colors);
    
    return;
    
}