/* Simple test program for the RAD package. */

/* Compute f(n,x) = the product of x[0], x[1], ..., x[n-1] */
/* and the gradient of f for two x values, and print the result. */

//#include "rad.hpp"
#include <stdio.h>
#include "mex.h"   //--This one is required
#define nanoMatDebug false // 1 for safety/error checking; 0 for faster and unsafe(er)
#include "nanoMatT.cpp"
#include "math.h"
#define mmin(X,Y) ((X) < (Y) ? (X) : (Y))
#define mmax(X,Y) ((X) > (Y) ? (X) : (Y))

/*
typedef nanoMat<double> dMat;
typedef nanoMat<int>    iMat;
typedef nanoMat<ADvar> adMat;
typedef ADvar var;
*/


typedef nanoMat<double> dMat;
typedef nanoMat<int>    iMat;
typedef nanoMat<double> adMat;
typedef double var;

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]){
    int i, j, k, l, m, n, y;
    
    dMat  X  = dMat(prhs[0]);
    dMat  Y  = dMat(prhs[1]);
    dMat  W  = dMat(prhs[2]);
    dMat  weight = dMat(prhs[3]);
    
    plhs[0] = mxCreateDoubleMatrix(1,1,mxREAL);
    dMat L = dMat(plhs[0]);
    
    plhs[1] = mxCreateDoubleMatrix(W.M,W.N,mxREAL);
    dMat dW = dMat(plhs[1]);
    
    int NY = W.M;
    int NX = X.M;
    
    dMat P(W.M,1,0.0);
    for(n=0; n<X.N; n++){
        for(y=0; y<NY; y++){
            P(y)=0;
            for(i=0; i<NX; i++)
                P(y) += W(y,i)*X(i,n);
            P(y)=exp(P(y));
        }
        P.norm_col(0);
                
        int myy = (int)Y(n)-1;
        L(0) += weight(n)*log(P(myy));
        for(i=0; i<X.M; i++)
            dW(myy,i) += weight(n)*X(i,n);
        for(y=0; y<W.M; y++)
            for(i=0; i<X.M; i++)
                dW(y,i) -= weight(n)*P(y)*X(i,n);
    }
    return;
    
}
