function W = fitlogreg(X,Y,weight,W0)

[D N] = size(X);

if nargin < 3 || isempty(weight)
    weight = 1+0*Y;
end
if nargin < 4 || isempty(W0)
    W0 = .01*randn(max(Y),D);
end

if size(Y,2) ~= size(X,2)
    error('inconsistent input sizes in fitlogreg');
end

lambda = 0*.01; % regularization rules

    function [L grad] = eval(W)
        W = reshape(W,size(W0));
        
        save W W
        
        [L grad] = eval_logreg(X,Y,W,weight);
        L    = -L/N;
        grad = -grad(:)/N;
        
        L    = L      + lambda*W(:)'*W(:);
        grad = grad + 2*lambda*W(:);
    end

     options = [];
     options.Display = 'iter';
     options.DerivativeCheck = 'off';
     options.GradObj = 'on';
     options.Method  = 'bfgs';
     options.TolFun  = 1e-6;
     options.MaxFunEvals = 10000;
     
     W = minFunc(@eval,W0(:),options);
     W = reshape(W,size(W0));
end