function [W V]  = fitmlp(X,Y,weight,W0,V0)

[dX D] = size(X);

if size(Y,2) ~= size(X,2)
    error('inconsistent input sizes in fitlogreg');
end

if isempty(weight)
    weight = 1+0*Y;
end

lambda = .0001; % regularization rules
lambda = 0*.1; % regularization rules

numW = numel(W0);
numV = numel(V0);

    function [L grad] = eval(params)
        W = reshape(params(1:numW    ),size(W0));
        V = reshape(params(numW+1:end),size(V0));
        
        save params W V
        
        [L gradW gradV] = eval_mlp(X,Y,W,V,weight);
        L    = -L/D;
        grad = -[gradW(:); gradV(:)]/D;
        
        L    = L      + lambda*params'*params;
        grad = grad + 2*lambda*params;
    end

     options = [];
     options.Display = 'on';
     options.DerivativeCheck = 'off';
     options.GradObj = 'on';
     options.Method  = 'bfgs';
     options.TolFun  = 1e-6;
     options.MaxFunEvals = 10000;
     
     params = [W0(:); V0(:)];
     params = minFunc(@eval,params,options);
     W = reshape(params(1:numW    ),size(W0));
     V = reshape(params(numW+1:end),size(V0));
     
     %W=W0; W(1,1)=W0(1,1); V=V0; V(1,1)=V0(1,1);
     %fitlogreg_2layer_stochgrad(X,Y,W,V,weight,.01);
end