function [W V] = fitmlp_stoch(X,Y,weight,W0,V0,stepsize,minstepsize)

[D N] = size(X);

if nargin < 3 || isempty(weight)
    weight = 1+0*Y;
end

if size(Y,2) ~= size(X,2)
    error('inconsistent input sizes in fitlogreg');
end

W=W0;W(1,1)=W0(1,1); % deep copy
V=V0;V(1,1)=V0(1,1); % deep copy
tic

% manually add constant term to X
%X = [X; ones(1,size(X,2))];
%tmp=Y(1); Y(1)=tmp; % force copy of Y because modified inplace below

if round(minstepsize)~=minstepsize
    rep = 1;
    while stepsize > minstepsize
        %perm = randperm(length(Y));
        %X    = X(:,perm);
        %Y    = Y(perm);
        perm = rand_inplace_perm(length(Y));
        X = inplace_perm(X,perm,1);
        Y = inplace_perm(Y,perm,1);

        L(rep)=fitmlp_stochgrad(X,Y,W,V,weight,stepsize);
        fprintf('time: %f  L/N: %f  stepsize: %f  minstepsize: %f\n', toc, L(rep)/N, stepsize, minstepsize);
        rep=rep+1;
        %plot(L); drawnow; pause(.01);

        %save params W V
        stepsize = stepsize * .75;
    end
else
    maxreps = minstepsize;
    for rep=1:maxreps
        %perm = randperm(length(Y));
        %X    = X(:,perm);
        %Y    = Y(perm);
        perm = rand_inplace_perm(length(Y));
        X = inplace_perm(X,perm,1);
        Y = inplace_perm(Y,perm,1);

        L(rep)=fitmlp_stochgrad(X,Y,W,V,weight,stepsize);
        fprintf('time: %f  L/N: %f  stepsize: %f  rep: %d  maxreps: %d\n', toc, L(rep)/N, stepsize, rep, maxreps);
    end
end
    
end
