function [myX myY im_scaled P_scaled] = get_data_scaled(howmany,imsdir,labelsdir,Aims,Alabels,i,layer,D,model,im_scaled,P_scaled)

num_scales = model.num_scales;
buf_size   = model.buf_size;
big_buf_size = buf_size*2^(num_scales-1);

im    = imread([imsdir    '/' Aims(i).name]);
im    = double(im)/255;
label = imread([labelsdir '/' Alabels(i).name]);

% reflect
label = reflectim(label,big_buf_size);

% hack to not recreate scalespace if not needed
if nargin < 10 || isempty(im_scaled) || ...
        sum(sum(abs(im(1:50,1:50)-im_scaled{1}(1+big_buf_size:50+big_buf_size,1+big_buf_size:50+big_buf_size))))
    im_scaled = get_scalespace(im,num_scales);
    for scale=1:num_scales
        im_scaled{scale} = reflectim(im_scaled{scale},big_buf_size);
    end
end

num_colors = size(im,3);

if layer>1
    filename=sprintf('TemporaryData/P%05d',i);
    load(filename,'Pint'); P=double(Pint)/model.bigint;
    %P = reflectim(P,big_buf_size); % train on whole image
    if nargin < 11 || isempty(P_scaled) || ...
            sum(sum(abs(P(1:50,1:50)-P_scaled{1}(1+big_buf_size:50+big_buf_size,1+big_buf_size:50+big_buf_size))))
        P_scaled = get_scalespace(P,num_scales);
        
        for scale=1:num_scales
            P_scaled{scale} = reflectim(P_scaled{scale},big_buf_size);
        end
    end
end

[ly lx lz] = size(im_scaled{1});
if lz ~= num_colors, error(['num_colors=' num2str(num_colors)
        ' yet, image has ' num2str(lz)]); end

% for scale=1:num_scales
%     step = 2^(scale-1);
%     [where00x where00y] = meshgrid(-buf_size*step:step:buf_size*step,...
%                                    -buf_size*step:step:buf_size*step);
%     where00 = where00y(:) + ly*where00x(:);
%     where0{scale} = [];
%     for z=1:lz
%         where0{scale} = [where0{scale}; where00+ly*lx*(z-1)];
%     end
% end

%imshow(im_scaled{1}); hold on

myX = zeros(D,howmany);
myY = zeros(1,howmany);
for rep=1:howmany
    my_label = 0;
    while my_label == 0
        y = big_buf_size + ceil(rand*(ly-2*big_buf_size));
        x = big_buf_size + ceil(rand*(lx-2*big_buf_size));
        my_label = label(y,x);
    end
    %plot(x,y,'r+');
    for scale=1:num_scales
        step = 2^(scale-1);
         patch = im_scaled{scale}(y-buf_size*step:step:y+buf_size*step,...
                                  x-buf_size*step:step:x+buf_size*step,:);
        patches(:,scale) = patch(:);
    end

    if layer>1
        for scale=1:num_scales
            step = 2^(scale-1);
             patch = im_scaled{scale}(y-buf_size*step:step:y+buf_size*step,...
                                      x-buf_size*step:step:x+buf_size*step,:);
             patches(:,scale) = patch(:);

             prob = P_scaled{scale}(y-buf_size*step:step:y+buf_size*step,...
                                    x-buf_size*step:step:x+buf_size*step,:);
             probs(:,scale) = prob(:);
        end
    end
    
    if layer>1
        x = [patches(:); probs(:)];
    else
        x = patches(:);
    end
    if size(x,1)<size(myX,1)
        padder=size(myX,1)-size(x,1);
        x=padarray(x,padder,0,'post');
    end
    myX(:,rep)=x;
    myY(:,rep)=my_label;
end
%hold off
%pause
end