function mixim=miximshow(probs,nlabels)

[ly lx lz] = size(probs);
if lz==1
    p = probs;
    if nargin < 2
        lz = max(p(:));
    else
        lz = nlabels;
    end
    probs = zeros(ly,lx,lz);
    for z=1:lz
        probs(:,:,z) = double(p==z);
    end
end

if lz==2
    mixim = repmat(probs(:,:,2),[1 1 3]);
elseif lz==5    
    cmap   = [[0 0 0]; [0 0 1]; [1 0 0]; [0 1 0]; [1 1 1]];
    layers = {'building', 'road', 'sky', 'foliage', 'cars'};

    % display mixed
    mixim = zeros(ly,lx,3);
    for i=1:lz
        for c=1:3
            mixim(:,:,c) = mixim(:,:,c) + cmap(i,c)*probs(:,:,i);
        end
    end
    elseif lz==4    
    cmap   = [[0 0 0]; [0 0 1]; [1 0 0]; [0 1 0]; ];
    layers = {'building', 'road', 'sky', 'foliage'};

    % display mixed
    mixim = zeros(ly,lx,3);
    for i=1:lz
        for c=1:3
            mixim(:,:,c) = mixim(:,:,c) + cmap(i,c)*probs(:,:,i);
        end
    end

    elseif lz==11    
    cmap   = [[.5 .5 .5]; [1 0 0]; [0 1 0]; [0 0 1]; [0 1 1]; [1 1 0]; [1 0 1]; [1 1 1]; [.5 0 0]; [0 .5 0]; [0 0 .5] ];
    layers = {'chest', 'rightarm', 'leftarm', 'righthand', 'lefthand','leftfemur','rightfemur','leftsock','rightsock','head','11'};

    % display mixed
    mixim = zeros(ly,lx,3);
    for i=1:lz
        for c=1:3
            mixim(:,:,c) = mixim(:,:,c) + cmap(i,c)*probs(:,:,i);
        end
    end
   elseif lz==8    
   cmap   = [[.5 .5 .5]; [1 0 0]; [0 1 0]; [0 0 1]; [0 1 1]; [1 1 0]; [1 0 1]; [0 0 .5] ];
   layers = {'chest', 'rightarm', 'leftarm', 'righthand', 'lefthand','leftfemur','head','background'};
 
    % display mixed
    mixim = zeros(ly,lx,3);
    for i=1:lz
        for c=1:3
            mixim(:,:,c) = mixim(:,:,c) + cmap(i,c)*probs(:,:,i);
            imwrite([probs(:,:,i)],['output' num2str(i) '.bmp']);
        end
    end
    elseif lz==21    
   cmap   = [[0 0 0]; [1 1 .5]; [1 1 1]; [0 .5 0]; [0 .5 .5]; [0 .5 1]; [0 1 0]; [0 1 .5]; [0 1 1];     [.5 0 0]; [.5 0 .5]; [.5 0 1]; [.5 .5 0]; [.5 .5 .5]; [.5 .5 1]; [.5 1 0]; [.5 1 .5]; [.5 1 1];      [1 0 0]; [1 0 .5]; [1 0 1]; [1 .5 0]; [1 .5 .5]];
   layers = {'1', '2', '3', '4', '5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','21'};
 
    % display mixed
    mixim = zeros(ly,lx,3);
    for i=1:lz
        for c=1:3
            mixim(:,:,c) = mixim(:,:,c) + cmap(i,c)*probs(:,:,i);
            %imwrite([probs(:,:,i)],['output' num2str(i) '.bmp']);
        end
    end
    imshow(mixim);
else
    error('currently unsupported number of labels for display (miximshow.m)');
end
if nargout==0
    imshow(mixim);
end