function J = myadapteq(RGB)

if ~isa(RGB,'double')
    error('myadapteq only takes doubles');
end

% Convert image to L*a*b* color space
cform2lab = makecform('srgb2lab');
LAB = applycform(RGB, cform2lab); 

% Scale values to range from 0 to 1
L = LAB(:,:,1)/100;

% Perform CLAHE
LAB(:,:,1) = adapthisteq(L,'NumTiles',...
                         [5 5],'ClipLimit',0.005)*100;

% Convert back to RGB color space
cform2srgb = makecform('lab2srgb');
J = double(applycform(LAB, cform2srgb)); 