/* Simple test program for the RAD package. */

/* Compute f(n,x) = the product of x[0], x[1], ..., x[n-1] */
/* and the gradient of f for two x values, and print the result. */

//#include "rad.hpp"
#include <stdio.h>
#include "mex.h"   //--This one is required
//#define nanoMatDebug 1 // 1 for safety/error checking; 0 for faster and unsafe(er)
#include "nanoMatT.cpp"
#include "math.h"
#define mmin(X,Y) ((X) < (Y) ? (X) : (Y))
#define mmax(X,Y) ((X) > (Y) ? (X) : (Y))

/*
typedef nanoMat<double> dMat;
typedef nanoMat<int>    iMat;
typedef nanoMat<ADvar> adMat;
typedef ADvar var;
*/


typedef nanoMat<double> dMat;
typedef nanoMat<int>    iMat;
typedef nanoMat<double> adMat;
typedef double var;

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]){
    int i, j, k, l, m, n, y;
    
    dMat  X  = dMat(prhs[0]);
    
    plhs[0] = mxCreateDoubleMatrix(X.M,X.N,mxREAL);
    dMat O = dMat(plhs[0]);
    
    // MATLAB
    //H = -10:.1:10;
    //A = tanh(H);
    //where = 1 + (X + 10)*10;
    //where = max(min(where,length(H)),1);

    //frac_lo = ceil(where)-where;
    //frac_hi = 1-frac_lo;
    //O = A(ceil(where)).*frac_hi + A(floor(where)).*frac_lo;
    
    // first, make table
    dMat A(201,1);
    for(i=0; i<201; i++)
        A(i) = tanh(-10 + .1*i);
    
    for(i=0; i<X.M*X.N; i++){
        double where = (X(i)+10)*10;
        where = mmax(mmin(where,200),0);

        int floorwhere = (int)where;
        int ceilwhere  = mmin(200,floorwhere+1);
        
        double frac_lo = ceilwhere-where;
        double frac_hi = 1-frac_lo;
        O(i) = A(ceilwhere)*frac_hi + A(floorwhere)*frac_lo;
    }
    
    return;
    
}