function im2 = reflectim(im,siz)
% reflect borders of size siz
% brute force doing all 8 cases separately, since that is really faster
% than a clean solution using coordinates...

[ly lx lz] = size(im);
for z=1:lz
im2(:,:,z) = zeros(ly+2*siz,lx+2*siz);

% original im
im2(siz+1:end-siz,siz+1:end-siz,z) = im(:,:,z);

% top
im2(1:siz,siz+1:end-siz,z) = flipud(im(1:siz,:,z));

% bot
im2(end-siz+1:end,siz+1:end-siz,z) = flipud(im(end-siz+1:end,:,z));

% left
im2(siz+1:end-siz,1:siz,z) = fliplr(im(:,1:siz,z));

% right
im2(siz+1:end-siz,end-siz+1:end,z) = fliplr(im(:,end-siz+1:end,z));

% top-left
im2(1:siz,1:siz,z) = rot90(im(1:siz,1:siz,z),2);

% top-right
im2(1:siz,end-siz+1:end,z) = rot90(im(1:siz,end-siz+1:end,z),2);

% bot-left
im2(end-siz+1:end,1:siz,z) = rot90(im(end-siz+1:end,1:siz,z),2);

% bot-right
im2(end-siz+1:end,end-siz+1:end,z) = rot90(im(end-siz+1:end,end-siz+1:end,z),2);
end